﻿//////////////////////////////////////////////
// Constants.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// Standards
#include <string>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	struct Constants
	{
		// Namespace
		inline static const std::string NAMESPACE = "nkGraphics" ;

		// UserTypes
		// Bounds
		inline static const std::string BOUNDING_BOX = NAMESPACE + "::BoundingBox" ;

		// Camera
		inline static const std::string CAMERA = NAMESPACE + "::Camera" ;
		inline static const std::string CAMERA_MANAGER = NAMESPACE + "::CameraManager" ;
		inline static const std::string FRUSTUM = NAMESPACE + "::Frustum" ;

		// Compositor
		inline static const std::string COMPOSITOR = NAMESPACE + "::Compositor" ;
		inline static const std::string COMPOSITOR_MANAGER = NAMESPACE + "::CompositorManager" ;
		inline static const std::string COMPOSITOR_NODE = NAMESPACE + "::CompositorNode" ;

		// Graph
		inline static const std::string ENTITY = NAMESPACE + "::Entity" ;
		inline static const std::string NODE = NAMESPACE + "::Node" ;
		inline static const std::string NODE_MANAGER = NAMESPACE + "::NodeManager" ;
		inline static const std::string SUB_ENTITY = NAMESPACE + "::SubEntity" ;

		// Meshes
		inline static const std::string DECODER_GLTF = NAMESPACE + "::GltfDecoder" ;
		inline static const std::string MESH = NAMESPACE + "::Mesh" ;
		inline static const std::string MESH_MANAGER = NAMESPACE + "::MeshManager" ;
		inline static const std::string VERTEX_COMPONENT = NAMESPACE + "::VertexComponent" ;
		inline static const std::string VERTEX_COMPONENT_ARRAY = NAMESPACE + "::VertexComponentArray" ;
		inline static const std::string VERTEX_COMPOSITION = NAMESPACE + "::VertexComposition" ;

		// Programs
		inline static const std::string PROGRAM = NAMESPACE + "::Program" ;
		inline static const std::string PROGRAM_MANAGER = NAMESPACE + "::ProgramManager" ;

		// RenderQueues
		inline static const std::string RENDER_QUEUE = NAMESPACE + "::RenderQueue" ;
		inline static const std::string RENDER_QUEUE_MANAGER = NAMESPACE + "::RenderQueueManager" ;

		// Shaders
		inline static const std::string SHADER = NAMESPACE + "::Shader" ;
		inline static const std::string SHADER_MANAGER = NAMESPACE + "::ShaderManager" ;

		// Textures
		inline static const std::string TEXTURE = NAMESPACE + "::Texture" ;
		inline static const std::string TEXTURE_MANAGER = NAMESPACE + "::TextureManager" ;
		inline static const std::string TEXTURE_SAVER = NAMESPACE + "::TextureSaver" ;
		inline static const std::string TEXTURE_UTILS = NAMESPACE + "::TextureUtils" ;

		// Viewports
		inline static const std::string VIEWPORT = NAMESPACE + "::Viewport" ;
		inline static const std::string VIEWPORT_MANAGER = NAMESPACE + "::ViewportManager" ;
	} ;
}