﻿//////////////////////////////////////////////
// QueuedRenderableObject.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Entity ;
	class Mesh ;
	class Shader ;
	class SubEntity ;
}

/// Class ------------------------------------

namespace nkGraphics
{
	class QueuedRenderableObject final
	{
		public :

			// Attributs
			// Données packées pour une interaction facile
			Shader* _attachedShader ;
			Mesh* _mesh ;
			SubEntity* _parentSubEnt ;
			Entity* _parentEnt ;

		public :

			// Constructeur, destructeur
			QueuedRenderableObject () ;
			QueuedRenderableObject (Shader* shade, Mesh* mesh, SubEntity* parentSubEnt, Entity* parentEnt) ;
			~QueuedRenderableObject () ;

			// Operators pour sorting
			bool isInfSortedNonTransparent (QueuedRenderableObject* other) const ;
			bool isInfSortedTransparent (QueuedRenderableObject* other) const ;
	} ;
}