﻿//////////////////////////////////////////////
// ShaderPassCustomSlot.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// Standards
#include <string>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ShaderPassCustomSlot
	{
		protected :
		
			// Attributs
			// Identification pour aider lors des imports / exports surtout
			std::string _typeName ;

		public :
	
			// Constructeur, destructeur
			ShaderPassCustomSlot () ;
			virtual ~ShaderPassCustomSlot () ;

			// Getters
			const char* getTypeName () const ;

			// Les fonctions à refaire pour les sous classes
			virtual unsigned int getDataByteSize () = 0 ;
			virtual void fillDataBuffer (void* buffer) = 0 ;
	} ;
}