﻿//////////////////////////////////////////////
// FileLogger.h
//
//////////////////////////////////////////////

/// Defines, macros --------------------------

#pragma once

/// Includes ---------------------------------

// nkLog
#include "Dll/DllDefines.h"

#include "Logger.h"

// Standards
#include <fstream>
#include <string>

/// Class ------------------------------------
	
namespace nkLog
{
	class DLL_LOG_EXPORT FileLogger final : public Logger
	{
		private :
		
			// Attributes
			// Le fichier de sortie
			std::ofstream _file ;
			// Son chemin qu'on garde au chaud
			std::string _filePath ;
			
		public :
		
			// Constructeur, destructeur
			FileLogger (std::string filePath) ;
			~FileLogger () ;

			// Getters
			std::string_view getOutputFilePath () const ;

			// Setters
			void setOutputFilePath (const std::string_view& path) ;

			// Actions
			virtual void log (const StringView& message, const StringView& className) override ;
	} ;
}