﻿//////////////////////////////////////////////
// ComponentManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Component ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "ComponentType.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>
#include <string>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT ComponentManager final : public nkCommon::SingletonClass<ComponentManager>
	{
		friend class nkCommon::SingletonClass<ComponentManager> ;

		private :
		
			// Constructeur, destructeur
			ComponentManager () ;
			~ComponentManager () ;

		private :

			// Attributs
			std::unordered_map<std::string, Component*> _components ;
		
		public :

			// Manipulation mémoire
			Component* createOrRetrieve (const std::string_view& name, COMPONENT_TYPE componentType) ;
			Component* get (const std::string_view& name) const ;
			Component* getByIndex (unsigned int index) const ;
			void erase (const std::string_view& name) ;
	} ;
}